<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<div class="w-full h-full text-white">
  <div *ngIf="initializing$ | async; else initialized" class="w-full h-full flex items-center justify-center">
    <app-spinner></app-spinner>
  </div>
  <ng-template #initialized>
    <ng-container *ngIf="(errorInitializing$ | async) == null; else onError">
      <ng-container *ngLet="node$ | async as selectedNode">
        <ng-container *ngLet="nodes$ | async as nodes">
          <ng-container *ngIf="!nodes || nodes.length > 0; else noNodes">
            <ng-container *ngLet="filteredNodes$ | async as filteredNodes">
              <div class="w-full h-full flex flex-col gap-4 pl-20">
                <div class="pt-20">
                  <input type="text" placeholder="Search..." pInputText [formControl]="search" [style]="{ width: '200px' }" />
                </div>
                <div class="w-full grow flex flex-col overflow-y-auto pb-20">
                  <div
                    *ngFor="let node of filteredNodes"
                    class="w-full hover:bg-secondary-900 cursor-pointer border-b border-borderGrey border-opacity-20 flex items-center gap-6 pl-4 pr-6 h-40"
                    (click)="selectNode(node)"
                    [ngClass]="{ 'bg-secondary-900': node.nodeId == selectedNode?.nodeId }"
                  >
                    <div class="grow">
                      <app-node-preview [node]="node" [isNew]="isNew(node)" [darkMode]="true"> </app-node-preview>
                    </div>
                    <app-node-options [node]="node"></app-node-options>
                    <i class="fa fa-chevron-right"></i>
                  </div>
                </div>
              </div>
            </ng-container>
          </ng-container>
          <ng-template #noNodes>
            <div class="w-full h-full flex flex-col items-center justify-center gap-4 opacity-90">
              <div class="text-lg font-semibold text-white">
                <app-sad-face></app-sad-face>
              </div>
              <div class="text-white">No Data Brokers</div>
            </div>
          </ng-template>
        </ng-container>
      </ng-container>
    </ng-container>
    <ng-template #onError>
      <div class="w-full h-full flex flex-col gap-4 items-center justify-center">
        <p-message severity="warning" text="Failed to load Data Brokers"></p-message>
        <p-button label="Try Again" [outlined]="true" size="small" (click)="onTryAgain()"></p-button>
      </div>
    </ng-template>
  </ng-template>
</div>
